#The script adds constant lines to the ABI file of any solidity version (for example, 0.8.6)
#so that it can be read in the ZHCash wallet
#Save your ABI to a text document abi.TXT and put it together with this script in the same folder
#After launch, the abi_zh.txt file will appear, which will be correctly read in the wallet
#--------------------------------------------------------------------------------------
#Скрипт добавляет в файл ABI любой версии солидити (например 0.8.6) строчки constant
#для того, чтобы он читался в кошельке ZHCash
#Сохраните своё ABI в текстовый документ abi.TXT и поместите его вместе с данным скриптом в одну папку
#После запуска появится файл abi_zh.txt, который будет правильно читаться в кошельке
import json
import pprint
if __name__ == '__main__':
    with open('abi.TXT') as json_file:
        data = json.load(json_file)
        print(data)
        pprint.pprint(data)
    for i,fun in enumerate(data):
        if fun['type'] == 'function' and (fun['stateMutability'] == 'view' or fun['stateMutability'] == 'pure'):
            data[i]['constant'] = True
        else:
            data[i]['constant'] = False
    with open('abi_zh.txt', 'w') as outfile:
        json.dump(data, outfile, indent = 4)
